/*
 * Funambol is a mobile platform developed by Funambol, Inc. 
 * Copyright (C) 2009 Funambol, Inc.
 * 
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Affero General Public License version 3 as published by
 * the Free Software Foundation with the addition of the following permission 
 * added to Section 15 as permitted in Section 7(a): FOR ANY PART OF THE COVERED
 * WORK IN WHICH THE COPYRIGHT IS OWNED BY FUNAMBOL, FUNAMBOL DISCLAIMS THE 
 * WARRANTY OF NON INFRINGEMENT  OF THIRD PARTY RIGHTS.
 * 
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
 * details.
 * 
 * You should have received a copy of the GNU Affero General Public License 
 * along with this program; if not, see http://www.gnu.org/licenses or write to
 * the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301 USA.
 * 
 * You can contact Funambol, Inc. headquarters at 643 Bair Island Road, Suite 
 * 305, Redwood City, CA 94063, USA, or at email address info@funambol.com.
 * 
 * The interactive user interfaces in modified source and object code versions
 * of this program must display Appropriate Legal Notices, as required under
 * Section 5 of the GNU Affero General Public License version 3.
 * 
 * In accordance with Section 7(b) of the GNU Affero General Public License
 * version 3, these Appropriate Legal Notices must retain the display of the
 * "Powered by Funambol" logo. If the display of the logo is not reasonably 
 * feasible for technical reasons, the Appropriate Legal Notices must display
 * the words "Powered by Funambol".
 */

#include "messageUtils.h"
#include "constants.h"

using namespace Funambol;


StringBuffer getStringBufferMessageFromCode(int code) {
    NSString* nsres = getMessageFromCode(code);
    StringBuffer res("");
    res.append([nsres UTF8String]);
    return res;
}

NSString* getMessageFromCode(int code, NSBundle* b)
{
    NSString* nsres;
    
    switch (code) {
        case kSyncSuccessful:
            nsres = NSLocalizedStringFromTableInBundle(@"codeSyncSuccessful",nil,b, @"-");
            break;
        case kCodeServerBadRequest:
            nsres = NSLocalizedStringFromTableInBundle(@"codeServerBadRequest",nil,b, @"-");
            break;            
        case kCodeWrongCredential:
            nsres = NSLocalizedStringFromTableInBundle(@"codeWrongCredential",nil,b, @"-");
            break;    
        case kCodeAuthExpired:
            nsres = NSLocalizedStringFromTableInBundle(@"codeAuthExpired",nil,b, @"-");
            break;
        case kCodeForbidden:
            nsres = NSLocalizedStringFromTableInBundle(@"codeForbidden",nil,b, @"-");
            break;
        case kCodeNotFound:
            nsres = NSLocalizedStringFromTableInBundle(@"codeNotFound",nil,b, @"-");
            break;
        case kCodeInvalidCredential:
            nsres = NSLocalizedStringFromTableInBundle(@"codeInvalidCredential",nil,b, @"-");
            break;
        case kCodeServerRequestTimeout:
            nsres = NSLocalizedStringFromTableInBundle(@"codeServerRequestTimeout",nil,b, @"-");
            break;
        case kCodeServerBusy:
            nsres = NSLocalizedStringFromTableInBundle(@"codeServerBusy",nil,b, @"-");
            break;
        case kCodeServerError:
            nsres = NSLocalizedStringFromTableInBundle(@"codeServerError",nil,b, @"-");
            break;   
        case kSyncCancelledByUser:
            nsres = NSLocalizedStringFromTableInBundle(@"codeSyncCancelledByUser",nil,b, @"-");
            break; 
        case kCodeServerErrorConnect:
            nsres = NSLocalizedStringFromTableInBundle(@"codeServerErrorConnect",nil,b, @"-");
            break; 
        default:
            nsres = NSLocalizedStringFromTableInBundle(@"codeGenericError",nil,b, @"-");
            break;
    }
    
    return nsres;
    
}

NSString* getMessageFromCode(int code)
{
    NSString* nsres;
    
    switch (code) {
        case kSyncSuccessful:
            nsres = NSLocalizedString(@"codeSyncSuccessful",@"-");
            break;
        case kCodeServerBadRequest:
            nsres = NSLocalizedString(@"codeServerBadRequest",@"-");
            break;            
        case kCodeWrongCredential:
            nsres = NSLocalizedString(@"codeWrongCredential",@"-");
            break;    
        case kCodeAuthExpired:
            nsres = NSLocalizedString(@"codeAuthExpired",@"-");
            break;
        case kCodeForbidden:
            nsres = NSLocalizedString(@"codeForbidden",@"-");
            break;
        case kCodeNotFound:
            nsres = NSLocalizedString(@"codeNotFound",@"-");
            break;
        case kCodeInvalidCredential:
            nsres = NSLocalizedString(@"codeInvalidCredential",@"-");
            break;
        case kCodeServerRequestTimeout:
            nsres = NSLocalizedString(@"codeServerRequestTimeout",@"-");
            break;
        case kCodeServerBusy:
            nsres = NSLocalizedString(@"codeServerBusy",@"-");
            break;
        case kCodeServerError:
            nsres = NSLocalizedString(@"codeServerError",@"-");
            break;   
        case kSyncCancelledByUser:
            nsres = NSLocalizedString(@"codeSyncCancelledByUser",@"-");
            break; 
        case kCodeServerErrorConnect:
            nsres = NSLocalizedString(@"codeServerErrorConnect",@"-");
            break; 
        default:
            nsres = NSLocalizedString(@"codeGenericError",@"-");
            break;
    }
    
    return nsres;
    
}

