#!/usr/bin/awk -f

BEGIN {
    FS="[ \t]*[ \t]\"*\"";
    APP_PREFIX="";
    APP_NAME="";
}

{
    split($1, define_tokens, " ");
    field_name=define_tokens[2];

    if (field_name ~ "APP_PREFIX_NAME") {
        split($2, tokens, "\"");
        APP_PREFIX=tokens[1];
        printf("%s=%s\n", field_name, APP_PREFIX); 
    } else if (field_name ~ "APPNAME") {
        split($2, tokens, "\"");
        APP_NAME=tokens[1];
        printf("%s=\"%s\"\n", field_name, APP_NAME); 
    } else if ((field_name ~ "SYNC_APPLICATION_NAME") || 
            (field_name ~ "MENUBAR_APPLICATION_NAME") ||
            (field_name ~ "UPDATER_APPLICATION_NAME")) {
        split(define_tokens[3], tokens, "\"");
        application_name=tokens[2];
        printf("%s=%s%s\n", field_name, APP_PREFIX, application_name);
    } else if  (field_name ~ "LAUNCHER_APPLICATION_NAME") {
        split($1, tokens, " ");
        printf("%s=\"%s\"\n", tokens[2], APP_NAME);
    } else if (field_name ~ "PREFERENCE_APPLICATION_NAME") {
        split(define_tokens[3], tokens, "\"");
        application_name=tokens[2];
        printf("%s=\"%s%s\"\n", field_name, APP_PREFIX, application_name);
    } else if (field_name ~ "PREFERENCES_PANEL_ID") {
        split($2, tokens, "\"");
        printf("%s=\"%s%s%s\"\n", field_name, tokens[1], APP_PREFIX, tokens[3]);
    } else if (field_name ~ "PREFERENCE_VISIBLE_NAME") {
        printf("%s=\"%s %s\n", field_name, APP_NAME, define_tokens[4]);
    } else if ((field_name ~ "LICENSE_FILE") || (field_name ~ "DISTRIBUITION_PROP_FILE") ||
            (field_name ~ "UNINSTALLER_APPLICATION_NAME")) {
        split($2, tokens, "\"");
        printf("%s=%s\n", field_name, tokens[1]);
    } else if (field_name ~ "POWEREDBY"){
        printf("%s=%s\n", field_name, define_tokens[3]);
    }
}
