/*
 * Funambol is a mobile platform developed by Funambol, Inc. 
 * Copyright (C) 2009 Funambol, Inc.
 * 
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Affero General Public License version 3 as published by
 * the Free Software Foundation with the addition of the following permission 
 * added to Section 15 as permitted in Section 7(a): FOR ANY PART OF THE COVERED
 * WORK IN WHICH THE COPYRIGHT IS OWNED BY FUNAMBOL, FUNAMBOL DISCLAIMS THE 
 * WARRANTY OF NON INFRINGEMENT  OF THIRD PARTY RIGHTS.
 * 
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
 * details.
 * 
 * You should have received a copy of the GNU Affero General Public License 
 * along with this program; if not, see http://www.gnu.org/licenses or write to
 * the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301 USA.
 * 
 * You can contact Funambol, Inc. headquarters at 643 Bair Island Road, Suite 
 * 305, Redwood City, CA 94063, USA, or at email address info@funambol.com.
 * 
 * The interactive user interfaces in modified source and object code versions
 * of this program must display Appropriate Legal Notices, as required under
 * Section 5 of the GNU Affero General Public License version 3.
 * 
 * In accordance with Section 7(b) of the GNU Affero General Public License
 * version 3, these Appropriate Legal Notices must retain the display of the
 * "Powered by Funambol" logo. If the display of the logo is not reasonably 
 * feasible for technical reasons, the Appropriate Legal Notices must display
 * the words "Powered by Funambol".
 */

// we use #import to make sure the header is only read in once

#import "AccountController.h"
#import "customization.h"
#import "ClientConfig.h"
USE_NAMESPACE

@implementation AccountController

- (id)init {
    self = [super init];    
    return self;
}

- (void) awakeFromNib{
    if(!(ClientConfig::getInstance()->getIsInitialized())){

        ClientConfig::getInstance()->init();
        ClientConfig::getInstance()->read();
    }
    NSBundle* b = [NSBundle bundleForClass:[self class]];

    [serverLabel setStringValue:NSLocalizedStringFromTableInBundle(@"serverText",nil,b, @"-")];
    [usernameLabel setStringValue:NSLocalizedStringFromTableInBundle(@"usernameText",nil,b, @"-")];
    [passwordLabel setStringValue:NSLocalizedStringFromTableInBundle(@"passwordText",nil,b, @"-")];
    
    const char* usernameValue = ClientConfig::getInstance()->getAccessConfig().getUsername();
    [usernameField setStringValue:[NSString stringWithCString:usernameValue encoding:NSUTF8StringEncoding]];
    
    const char* passwordValue = ClientConfig::getInstance()->getAccessConfig().getPassword();
    [passwordField setStringValue:[NSString stringWithCString:passwordValue encoding:NSUTF8StringEncoding]];
    
    const char* serverValue = ClientConfig::getInstance()->getAccessConfig().getSyncURL();
    [serverField setStringValue:[NSString stringWithCString:serverValue encoding:NSUTF8StringEncoding]];
    
    [accountMessage setStringValue:NSLocalizedStringFromTableInBundle(@"accountMessageText", nil, b, @"-")];
    
}

- (NSString*) getApplicationName {
    
    NSString* appName = [NSString stringWithUTF8String:APPNAME];
    return appName;
}


- (IBAction) getUsername: (id) pId{
    if(!CUSTOM_CHECK_CREDENTIALS_ON_EXIT){
        NSString* nval = [pId stringValue];
        const char* val = [nval UTF8String];
        ClientConfig::getInstance()->getAccessConfig().setUsername(val);
        ClientConfig::getInstance()->safeSave();
    }
}
- (IBAction) getPassword: (id) ppId{
    
    if(!CUSTOM_CHECK_CREDENTIALS_ON_EXIT){
        NSString* nval = [ppId stringValue];
        const char* val = [nval UTF8String];
        ClientConfig::getInstance()->getAccessConfig().setPassword(val);
        ClientConfig::getInstance()->safeSave();
    }
    
}
- (IBAction) getServer: (id) pppId{
    
    if(!CUSTOM_CHECK_CREDENTIALS_ON_EXIT){
        NSString* nval = [pppId stringValue];
        const char* val = [nval UTF8String];
        ClientConfig::getInstance()->getAccessConfig().setSyncURL(val);
        ClientConfig::getInstance()->safeSave();
    }
}

@end