
/*
 * Funambol is a mobile platform developed by Funambol, Inc. 
 * Copyright (C) 2009 Funambol, Inc.
 * 
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Affero General Public License version 3 as published by
 * the Free Software Foundation with the addition of the following permission 
 * added to Section 15 as permitted in Section 7(a): FOR ANY PART OF THE COVERED
 * WORK IN WHICH THE COPYRIGHT IS OWNED BY FUNAMBOL, FUNAMBOL DISCLAIMS THE 
 * WARRANTY OF NON INFRINGEMENT  OF THIRD PARTY RIGHTS.
 * 
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
 * details.
 * 
 * You should have received a copy of the GNU Affero General Public License 
 * along with this program; if not, see http://www.gnu.org/licenses or write to
 * the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301 USA.
 * 
 * You can contact Funambol, Inc. headquarters at 643 Bair Island Road, Suite 
 * 305, Redwood City, CA 94063, USA, or at email address info@funambol.com.
 * 
 * The interactive user interfaces in modified source and object code versions
 * of this program must display Appropriate Legal Notices, as required under
 * Section 5 of the GNU Affero General Public License version 3.
 * 
 * In accordance with Section 7(b) of the GNU Affero General Public License
 * version 3, these Appropriate Legal Notices must retain the display of the
 * "Powered by Funambol" logo. If the display of the logo is not reasonably 
 * feasible for technical reasons, the Appropriate Legal Notices must display
 * the words "Powered by Funambol".
 */

#import <AppKit/AppKit.h>
#import <AppKit/NSButtonCell.h>
#import "LaunchCtlConfigManager.h"

@interface SyncController : NSControl
{
    //Outlet used for localization of the strings
    IBOutlet NSTextField* syncWithServer;
    IBOutlet NSTextField* syncDirection;
    IBOutlet NSPopUpButton* scheduleBox;
    IBOutlet NSPopUpButton* direction;
    IBOutlet NSButton* showInMenuBar;
    IBOutlet NSButton* syncButton;
    
    IBOutlet NSWindow* emptyCredential;
    
    IBOutlet NSWindow* firstSyncWarning;
    IBOutlet NSTextField* firstSyncText;
    IBOutlet NSButton* firstSyncOk;
    IBOutlet NSButton* firstSyncCancel;
    IBOutlet NSTabView* tabViewTemp;

    NSTask* synctask;
    LaunchCtlConfigManager* scheduledSyncManager;
    NSDistributedNotificationCenter* nCenter;
    BOOL menuBarUiEnabled;
    
    IBOutlet NSWindow* emptyWarning;
    IBOutlet NSTextField* emptyText;
    IBOutlet NSButton* emptyOk;
    
    IBOutlet NSTabViewItem* accountTab;
    
    ArrayList* scheduleValues;
}

- (void) awakeFromNib;
- (id) init;
- (void) dealloc;

- (NSString*) getApplicationName;
- (IBAction)syncWithServerAction:(id)pId; 
- (IBAction)syncDirectionAction:(id)pId; 
- (IBAction)showStatusInMenuBarAction:(id)pId; 
- (IBAction)syncAddressBookAction:(id)pId; 
- (IBAction)firstSyncOkAction:(id)pId; 
- (IBAction)firstSyncCancelAction:(id)pId; 
- (IBAction)emptyOkAction:(id)pId; 

- (void)modalSheetDidEnd:(NSWindow*)sheet returnCode:(int)returnCode contextInfo:(void *)contextInfo;

- (void)startSync;
- (void)checkSyncProcessStatus:(NSNotification *) aNotification;
- (void)syncStartedCallBack:(NSNotification *) aNotification;
- (void) syncCancelledCallBack:(NSNotification *) aNotification;
- (void)syncEndedCallBack:(NSNotification *) aNotification;

- (void)showMenuBarUi;
- (void)hideMenubarUi;

@end
