/*
 * Funambol is a mobile platform developed by Funambol, Inc. 
 * Copyright (C) 2009 Funambol, Inc.
 * 
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Affero General Public License version 3 as published by
 * the Free Software Foundation with the addition of the following permission 
 * added to Section 15 as permitted in Section 7(a): FOR ANY PART OF THE COVERED
 * WORK IN WHICH THE COPYRIGHT IS OWNED BY FUNAMBOL, FUNAMBOL DISCLAIMS THE 
 * WARRANTY OF NON INFRINGEMENT  OF THIRD PARTY RIGHTS.
 * 
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
 * details.
 * 
 * You should have received a copy of the GNU Affero General Public License 
 * along with this program; if not, see http://www.gnu.org/licenses or write to
 * the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301 USA.
 * 
 * You can contact Funambol, Inc. headquarters at 643 Bair Island Road, Suite 
 * 305, Redwood City, CA 94063, USA, or at email address info@funambol.com.
 * 
 * The interactive user interfaces in modified source and object code versions
 * of this program must display Appropriate Legal Notices, as required under
 * Section 5 of the GNU Affero General Public License version 3.
 * 
 * In accordance with Section 7(b) of the GNU Affero General Public License
 * version 3, these Appropriate Legal Notices must retain the display of the
 * "Powered by Funambol" logo. If the display of the logo is not reasonably 
 * feasible for technical reasons, the Appropriate Legal Notices must display
 * the words "Powered by Funambol".
 */


#import <AppKit/AppKit.h>
#import "updater/UpdaterConfig.h"
#import "base/util/StringBuffer.h"
USE_NAMESPACE

@interface UpdaterController : NSControl
{
    //Outlet used for localization of the strings
    IBOutlet NSWindow* alertRecommended;
    IBOutlet NSTextField* alertRecommendedText;
    IBOutlet NSTextField* alertRecommendedText2;
    IBOutlet NSButton* okReccomended;
    IBOutlet NSButton* cancelReccomended;
    IBOutlet NSImageView* reccomendedImage;
    
    IBOutlet NSWindow* alert;
    IBOutlet NSTextField* alertNormalText;
    IBOutlet NSButton* okNormal;
    IBOutlet NSButton* cancelNormal;
    IBOutlet NSButton* skipNormal;
    IBOutlet NSImageView* normalImage;
    
    IBOutlet NSWindow* alertUpdateManually;
    IBOutlet NSButton* okUpdateManually;
    IBOutlet NSImageView* updateManuallyImage;
    IBOutlet NSTextField* alertUpdateManuallyText;
    
    
    NSModalSession updater_session;
    int alertVal;
    int alertRecommendedVal;
    
    IBOutlet NSWindow* progressWindow;
    IBOutlet NSProgressIndicator* progressBar;
    IBOutlet NSTextField* progressText;
    IBOutlet NSTextField* progressStatusText;
    IBOutlet NSImageView* progressImage;
    IBOutlet NSButton* okProgress;
    
    IBOutlet NSWindow* errorWindow;
    IBOutlet NSTextField* errorText;
    IBOutlet NSButton* errorButton;
    IBOutlet NSImageView* errorImage;
    
    
    
    unsigned long bytesReceived;
    NSURLResponse * downloadResponse;
    
    NSTask* ziptask;
    
    UpdaterConfig* upconfig;
    StringBuffer* downloadedZipFile;
    
}

- (void) awakeFromNib;
- (id) init;
- (NSString*) getApplicationName;
- (int) showRecommendedAlert;
- (int) showNormalAlert;
- (int) showProgressWindow;
- (int) showUpdateManuallyAlert;

- (void) showErrorWithString:(NSString*)text;

- (void)modalSheetDidEnd:(NSWindow*)sheet returnCode:(int)returnCode contextInfo:(void *)contextInfo;

- (IBAction) okAlertNormal:(id)sender;
- (IBAction) cancelAlertNormal:(id)sender;
- (IBAction) laterAlertNormal:(id)sender;

- (IBAction) okProgress:(id)sender;

- (IBAction) okError:(id)sender;

- (IBAction) okAlertR:(id)sender;
- (IBAction) cancelAlertR:(id)sender;

- (void)download:(NSURLDownload *)download didFailWithError:(NSError *)error;
- (void)downloadDidFinish:(NSURLDownload *)download;
- (void)download:(NSURLDownload *)download didReceiveDataOfLength:(unsigned)length;
- (void)setDownloadResponse:(NSURLResponse *)aDownloadResponse;
- (void)download:(NSURLDownload *)download didReceiveResponse:(NSURLResponse *)response;
- (void)checkZipTaskStatus:(NSNotification *) aNotification;


- (void) downloadTask;
- (void) unzipTask;
- (void) installTask;
- (void) storeConf;

@end